#include "iostm8l152c6.h"
#include "LCD.H"
#include "add.h"

#define KEYPRESSED !PC_IDR_bit.IDR1

long int data[6];
enum category { MINUTE,
                HOUR };
category choice = MINUTE;


void delay( void )
{
  for ( long int i = 0; i < 200000; i++ )
    ;
  return;
}



#pragma vector=EXTI1_vector 
__interrupt void Pin1_interrupt(void) 
{
  delay(); //- 
  if ( !KEYPRESSED ) //  ,  
  {
    PC_ODR_bit.ODR7 = 1; // ...
    PE_ODR_bit.ODR7 = 1; //...  
    delay(); //
    PC_ODR_bit.ODR7 = 0; //...
    PE_ODR_bit.ODR7 = 0; //...
    RTC_WPR = 0xCA; // 
    RTC_WPR = 0x53;
    RTC_ISR1_bit.INIT = 1; //    
    while ( RTC_ISR1_bit.INITF == 0 ); //,    
    RTC_TR1 = CodNum( 0 ); //   0
    RTC_ISR1_bit.INIT = 0;  //   
    RTC_WPR = 0x00;   // 
    EXTI_SR1_bit.P1F = 1; //  ,    
    return; //     PC_DDR_bit.DDR7 = 1;
  PC_CR1_bit.C17 = 1;
  PE_DDR_bit.DDR7 = 1;
  PE_CR1_bit.C17 = 1;
  }
    
  
  if ( choice == MINUTE ) //   
  {
    long int i = 0;
    PC_ODR_bit.ODR7 = 1; //  
    while ( KEYPRESSED ) //  
    {
      LCD_Write_Int( &i, -1 ); // 
      delay(); //
      i++; // 
      LCD_Write_Int( &i, -1 );// 
      if ( i == 60 ) i = 0; //    60 -   
    }
    PC_ODR_bit.ODR7 = 0; // 
    //     
    RTC_WPR = 0xCA;
    RTC_WPR = 0x53;
    RTC_ISR1_bit.INIT = 1;
    while ( RTC_ISR1_bit.INITF == 0 );
    RTC_TR2 = CodNum( i - 1 ); 
    RTC_ISR1_bit.INIT = 0;
    RTC_WPR = 0x00;
    choice = HOUR; //      
    EXTI_SR1_bit.P1F = 1; 
    return;
  }
  
  if ( choice == HOUR ) //    
  {
    long int i = 0;
    PE_ODR_bit.ODR7 = 1;
    while ( KEYPRESSED )
    {
      LCD_Write_Int( &i, -1 );
      delay();
      i++;
      LCD_Write_Int( &i, -1 );
      if ( i == 24 ) i = 0; //    0    24
    }
    PE_ODR_bit.ODR7 = 0;
    RTC_WPR = 0xCA;
    RTC_WPR = 0x53;
    RTC_ISR1_bit.INIT = 1;
    while ( RTC_ISR1_bit.INITF == 0 );
    RTC_TR3 = CodNum( i - 1 ); 
    RTC_ISR1_bit.INIT = 0;
    RTC_WPR = 0x00;
    choice = MINUTE; //      
    EXTI_SR1_bit.P1F = 1;
    return;
  }
}

long int num_t;


int main()
{
  CLK_CKDIVR = 0; //  
  CLK_PCKENR2_bit.PCKEN22 = 1;  // 
  CLK_CRTCR_bit.RTCSEL3 = 1;  //  
  LCD_Init(); // 
  LCD_Contrast( 7 ); //   
    
  //       
  PC_DDR_bit.DDR7 = 1;
  PC_CR1_bit.C17 = 1;
  PE_DDR_bit.DDR7 = 1;
  PE_CR1_bit.C17 = 1;
  
  // 
  PC_DDR_bit.DDR1 = 0; //    
  PC_CR1_bit.C11 = 1; //  push-pull
  PC_CR2_bit.C21 = 1; // 
  EXTI_CR1_bit.P1IS = 2;  //  
  asm( "RIM" );  //  
  
  while(true)
  {
    while ( !RTC_ISR1_bit.RSF ); //   
    //  
    data[0] = GetNum( RTC_TR1 ); 
    data[1] = GetNum( RTC_TR2 );
    data[2] = GetNum( RTC_TR3 );
    data[3] = GetNum( RTC_DR1 );
    data[4] = GetNum( RTC_DR2 );
    data[5] = GetNum( RTC_DR3 );
    num_t = data[2]*10000 + data[1]*100 + data[0]; //   
    LCD_Write_Int( &num_t, -1 ); //    
    LCD_RAM7 = 0x88; //   
  }
  return 0;
}
